## xsystem35 2.13.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

# Rebuild external projects when download URL changes
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
  cmake_policy(SET CMP0135 NEW)
endif()

project(xsystem35 LANGUAGES C)
set(CMAKE_C_STANDARD 99)
enable_testing()
set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)

set(XSYSTEM35_VERSION "2.13.0")

include(CheckSymbolExists)
include(FetchContent)

# A wrapper around pkg_check_modules() that skips the check if ENABLE_<prefix> is false
macro (optional_pkg_check_modules prefix)
  option(ENABLE_${prefix} "Use ${prefix} if available" ON)
  if (ENABLE_${prefix})
    pkg_check_modules(${prefix} ${ARGN})
  endif()
endmacro()

# Generates a static library from pkg_check_modules() result
function(add_static_library name pkg)
  add_library(${name} INTERFACE)
  set_target_properties(${name}
      PROPERTIES
          INTERFACE_INCLUDE_DIRECTORIES "${${pkg}_STATIC_INCLUDE_DIRS}"
          INTERFACE_COMPILE_OPTIONS "${${pkg}_STATIC_CFLAGS_OTHER}"
          INTERFACE_LINK_LIBRARIES "${${pkg}_STATIC_LIBRARIES}"
          INTERFACE_LINK_OPTIONS "${${pkg}_STATIC_LDFLAGS_OTHER}")
endfunction()

function(fetch_webp)
  FetchContent_Declare(
    libwebp
    URL https://storage.googleapis.com/downloads.webmproject.org/releases/webp/libwebp-1.4.0.tar.gz
    URL_HASH SHA1=0b1c8bea200caaa010182609dbaaa91aec69b64d
    )
  set(WEBP_BUILD_ANIM_UTILS OFF CACHE BOOL "Build animation utilities." FORCE)
  set(WEBP_BUILD_CWEBP OFF CACHE BOOL "Build the cwebp command line tool." FORCE)
  set(WEBP_BUILD_DWEBP OFF CACHE BOOL "Build the dwebp command line tool." FORCE)
  set(WEBP_BUILD_GIF2WEBP OFF CACHE BOOL "Build the gif2webp conversion tool." FORCE)
  set(WEBP_BUILD_IMG2WEBP OFF CACHE BOOL "Build the img2webp animation tool." FORCE)
  set(WEBP_BUILD_VWEBP OFF CACHE BOOL "Build the vwebp viewer tool." FORCE)
  set(WEBP_BUILD_WEBPINFO OFF CACHE BOOL "Build the webpinfo command line tool." FORCE)
  set(WEBP_BUILD_LIBWEBPMUX OFF CACHE BOOL "Build the libwebpmux library." FORCE)
  set(WEBP_BUILD_WEBPMUX OFF CACHE BOOL "Build the webpmux command line tool." FORCE)
  set(WEBP_BUILD_EXTRAS OFF CACHE BOOL "Build extras." FORCE)
  set(WEBP_BUILD_WEBP_JS OFF CACHE BOOL "Emscripten build of webp.js." FORCE)
  FetchContent_MakeAvailable(libwebp)
  add_library(WebP ALIAS webp)
endfunction()

check_symbol_exists(getlogin "unistd.h" HAVE_GETLOGIN)
check_symbol_exists(mmap "sys/mman.h" HAVE_MMAP)
check_symbol_exists(sigaction "signal.h" HAVE_SIGACTION)

if (EMSCRIPTEN)
  function(add_emscripten_library name option)
    add_library(${name} INTERFACE)
    set_target_properties(${name} PROPERTIES
        INTERFACE_COMPILE_OPTIONS ${option}
        INTERFACE_LINK_OPTIONS ${option})
  endfunction()
  add_emscripten_library(zlib -sUSE_ZLIB=1)
  add_emscripten_library(sdl2 -sUSE_SDL=2)
  add_emscripten_library(sdl2_ttf -sUSE_SDL_TTF=2)
  set(DEFAULT_FONT_PATH /fonts/)
  fetch_webp()
  set(HAVE_WEBP 1)

elseif (ANDROID)
  add_library(sdl2 ALIAS SDL2)
  add_library(sdl2_ttf ALIAS SDL2_ttf)
  add_library(sdl2_mixer ALIAS SDL2_mixer)
  find_library(ndk_log log)
  find_library(ndk_zlib z)
  add_library(zlib INTERFACE)
  set_target_properties(zlib PROPERTIES INTERFACE_LINK_LIBRARIES ${ndk_zlib})
  fetch_webp()
  set(HAVE_WEBP 1)

else()  # non-emscripten, non-android
  if (WIN32)
    set(ZLIB_USE_STATIC_LIBS ON)
  endif()
  find_package(ZLIB REQUIRED)
  add_library(zlib ALIAS ZLIB::ZLIB)

  include(FindPkgConfig)
  optional_pkg_check_modules(GTK3 IMPORTED_TARGET gtk+-3.0)
  if (GTK3_FOUND)
    set(ENABLE_GTK 1)
  endif()

  pkg_check_modules(SDL2 REQUIRED IMPORTED_TARGET sdl2)
  pkg_check_modules(SDL2TTF REQUIRED IMPORTED_TARGET SDL2_ttf)
  pkg_check_modules(SDL2MIXER REQUIRED IMPORTED_TARGET SDL2_mixer)
  if (WIN32)
    add_static_library(sdl2 SDL2)
    add_static_library(sdl2_ttf SDL2TTF)
    # Workaround for linking error
    set_property(TARGET sdl2_ttf PROPERTY INTERFACE_LINK_LIBRARIES
        $<LINK_GROUP:RESCAN,${SDL2TTF_STATIC_LIBRARIES} -lstdc++>)
    add_static_library(sdl2_mixer SDL2MIXER)
  else()
    add_library(sdl2 ALIAS PkgConfig::SDL2)
    add_library(sdl2_ttf ALIAS PkgConfig::SDL2TTF)
    add_library(sdl2_mixer ALIAS PkgConfig::SDL2MIXER)
    set(DEFAULT_FONT_PATH ${CMAKE_INSTALL_PREFIX}/share/xsystem35/fonts/)
  endif()

  option(ENABLE_DEBUGGER "Enable built-in debugger" ON)
  if (ENABLE_DEBUGGER)
    pkg_check_modules(cJSON IMPORTED_TARGET libcjson)
    if (cJSON_FOUND)
      if (WIN32)
        add_static_library(cJSON cJSON)
      else ()
        add_library(cJSON ALIAS PkgConfig::cJSON)
      endif()
    else ()
      # libcjson-dev of Debian buster / Ubuntu 20.04 does not install pkgconfig files.
      find_library(cJSON cjson)
      if (NOT cJSON)
        message(FATAL_ERROR "libcjson is required but not found.")
      endif()
      add_library(cJSON ALIAS ${cJSON})
    endif()
  endif()

  optional_pkg_check_modules(WEBP IMPORTED_TARGET libwebp)
  if (WEBP_FOUND)
    set(HAVE_WEBP 1)
    if (WIN32)
      add_static_library(WebP WEBP)
    else()
      add_library(WebP ALIAS PkgConfig::WEBP)
    endif()
  endif()

  if (WIN32)
    optional_pkg_check_modules(PORTMIDI IMPORTED_TARGET portmidi)
    if (PORTMIDI_FOUND)
      set(HAVE_PORTMIDI 1)
      add_static_library(portmidi_static PORTMIDI)
      set(PORTMIDI portmidi_static)
    endif()
  else ()
    find_library(PORTMIDI portmidi)
    if (PORTMIDI)
      set(HAVE_PORTMIDI 1)
    endif()
  endif()
endif()

# Menu

if (ENABLE_GTK)
  # i18n support (currently only menus are translated)
  include(FindIntl)
  include(FindGettext)
  if (Intl_FOUND AND GETTEXT_FOUND)
    set(ENABLE_NLS 1)
    add_compile_definitions(LOCALEDIR="${CMAKE_INSTALL_PREFIX}/share/locale")
    include_directories(${Intl_INCLUDE_DIRS})
    link_libraries(${Intl_LIBRARIES})
  endif()
endif()

# PCM audio

if (EMSCRIPTEN)
  list(APPEND SUMMARY_AUDIO "Emscripten")
else()
  list(APPEND SUMMARY_AUDIO "SDL_mixer")
endif()

# CDROM

if (EMSCRIPTEN)
  list(APPEND SUMMARY_CDROM "Emscripten")
else()
  list(APPEND SUMMARY_CDROM "SDL_mixer (wav|mp3|ogg...)")
endif()
set(DEFAULT_PLAYLIST_PATH "playlist.txt" CACHE STRING "Default playlist path")

# MIDI

if (EMSCRIPTEN)
  list(APPEND SUMMARY_MIDI "Emscripten")
elseif (ANDROID)
  list(APPEND SUMMARY_MIDI "Android")
else()
  list(APPEND SUMMARY_MIDI "SDL_mixer")
  set(ENABLE_MIDI_SDLMIXER 1)

  if (HAVE_PORTMIDI)
    list(APPEND SUMMARY_MIDI "PortMidi")
    set(ENABLE_MIDI_PORTMIDI 1)
  endif()
endif()

function (print_summary name)
  if (ARGN)
    list(JOIN ARGN ", " MSG)
  else()
    set(MSG "none")
  endif()
  message(" ${name}: ${MSG}")
endfunction()

message("xsystem35 summary:")
message("------------------")
print_summary(audio ${SUMMARY_AUDIO})
print_summary(cdrom ${SUMMARY_CDROM})
print_summary(midi ${SUMMARY_MIDI})
message("------------------")

set(PACKAGE ${PROJECT_NAME})
configure_file(config.h.in config.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})
add_compile_definitions($<$<CONFIG:Debug>:DEBUG>)

add_subdirectory(src)
add_subdirectory(tools)
add_subdirectory(fonts)
if (NOT ANDROID AND NOT EMSCRIPTEN)
  add_subdirectory(doc)
endif()
if (ENABLE_NLS)
  add_subdirectory(po)
endif()

add_subdirectory(modules)
target_link_libraries(xsystem35 PRIVATE modules)

=== modules/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src)

add_library(modules STATIC
  modules.c
  AliceLogo/AliceLogo.c
  Confirm/Confirm.c
  Gpx/Gpx.c
  Gpx/effectcopy.c
  Math/Math.c
  MsgSkip/MsgSkip.c
  NIGHTDLL/NIGHTDLL.c
  NIGHTDLL/nt_scenario.c
  NIGHTDLL/sactcg.c
  NIGHTDLL/sactstring.c
  NIGHTDLL/sprite.c
  NIGHTDLL/sprite_draw.c
  NIGHTDLL/sprite_update.c
  NIGHTDLL/sprite_eupdate.c
  NIGHTDLL/nt_event.c
  NIGHTDLL/nt_msg.c
  NIGHTDLL/nt_sel.c
  NIGHTDLL/nt_graph.c
  NIGHTDLL/nt_sound.c
  NightDemonDemo/NightDemonDemo.c
  RandMT/RandMT.c
  SACT/SACT.c
  SACT/sactcg.c
  SACT/sactsound.c
  SACT/sacttimer.c
  SACT/sactstring.c
  SACT/sactcrypto.c
  SACT/sactchart.c
  SACT/sactamask.c
  SACT/sactlog.c
  SACT/sprite.c
  SACT/sprite_event.c
  SACT/sprite_tevent.c
  SACT/sprite_move.c
  SACT/sprite_anime.c
  SACT/sprite_get.c
  SACT/sprite_put.c
  SACT/sprite_switch.c
  SACT/sprite_sel.c
  SACT/sprite_msg.c
  SACT/sprite_draw.c
  SACT/sprite_update.c
  SACT/sprite_eupdate.c
  SACT/sprite_quake.c
  SACT/sprite_keywait.c
  SACT/screen_quake.c
  SACT/sprite_xmenu.c
  ShArray/ShArray.c
  ShCalc/ShCalc.c
  ShGraph/ShGraph.c
  ShPort/ShPort.c
  ShSound/ShSound.c
  ShString/ShString.c
  dDemo/dDemo.c
  eDemo/eDemo.c
  eeDemo/eeDemo.c
  lib/alk.c
  lib/drawtext.c
  lib/graph.c
  lib/list.c
  lib/surface.c
  lib/cg.c
  lib/graph_expandcolor_blend.c
  lib/graph_fillrect.c
  lib/graph_fillrect_amap.c
  lib/graph_fillrect_acolor.c
  lib/graph_rect.c
  lib/graph_copy.c
  lib/graph_copy_amap.c
  lib/graph_copy_bright.c
  lib/graph_blend_amap.c
  lib/graph_blend_screen.c
  lib/graph_saturadd_amap.c
  lib/graph_draw_amap.c
  lib/graph_stretch.c
  lib/graph_cg.c
  lib/gre_blend_useamap.c
  lib/gre_blend.c
  lib/gre_blend_screen.c
  nDEMO/nDEMO.c
  nDEMOE/nDEMOE.c
  oDEMO/oDEMO.c
  oujimisc/oujimisc.c
  tDemo/tDemo.c
  )

target_include_directories(modules PUBLIC . lib)

if (NOT ANDROID AND NOT EMSCRIPTEN)
  add_executable(modules_tests lib/list_test.c)
  target_link_libraries(modules_tests PRIVATE modules)
  add_test(NAME modules_tests COMMAND modules_tests)
endif()

target_compile_options(modules PRIVATE -Wno-pointer-sign)

target_link_libraries(modules PRIVATE sdl2 zlib)
if (TARGET sdl2_mixer)
  target_link_libraries(modules PRIVATE sdl2_mixer)
endif()

=== src/CMakeLists.txt ===
add_library(src_lib STATIC
  gameresource.c
  hankaku.c
  msgqueue.c
  utfsjis.c
  )
target_compile_options(src_lib PRIVATE -Wno-pointer-sign -Wall)
target_include_directories(src_lib PRIVATE .)

if (ANDROID)
  add_library(xsystem35 SHARED)
else()
  add_executable(xsystem35)
  if (WIN32)
    target_link_options(xsystem35 PRIVATE -static)
  endif()
endif()

target_compile_options(xsystem35 PRIVATE -Wno-pointer-sign $<$<CONFIG:Debug>:-Wall>)
target_include_directories(xsystem35 PRIVATE .)
target_link_libraries(xsystem35 PRIVATE src_lib)

target_sources(xsystem35 PRIVATE
  ags.c
  ald_manager.c
  alpha_plane.c
  bgi.c
  bmp.c
  cache.c
  cali.c
  cdrom.bgm.c
  cg.c
  cmd2F.c
  cmd2F60.c
  cmd_check.c
  cmdb.c
  cmdc.c
  cmdd.c
  cmde.c
  cmdf.c
  cmdg.c
  cmdh.c
  cmdi.c
  cmdj.c
  cmdk.c
  cmdl.c
  cmdm.c
  cmdn.c
  cmdo.c
  cmdp.c
  cmdq.c
  cmds.c
  cmdt.c
  cmdu.c
  cmdv.c
  cmdw.c
  cmdy.c
  cmdz.c
  cursor.c
  dri.c
  ecopy.c
  filecheck.c
  font.c
  hacks.c
  image.c
  input.c
  jpeg.c
  message.c
  midi.c
  mmap.c
  msgskip.c
  mt19937-1.c
  music.c
  music_cdrom.c
  music_midi.c
  nact.c
  network.c
  pms.c
  profile.c
  qnt.c
  s39ain.c
  savedata.c
  scenario.c
  sdl_cursor.c
  sdl_draw.c
  sdl_effect.c
  sdl_event.c
  sdl_image.c
  sdl_video.c
  selection.c
  texthook.c
  variable.c
  vsp.c
  xsystem35.c
  )

if (EMSCRIPTEN)
  target_sources(xsystem35 PRIVATE pcm.emscripten.c bgm.emscripten.c)
else()
  target_sources(xsystem35 PRIVATE pcm.sdlmixer.c bgm.sdlmixer.c)
endif()

if (EMSCRIPTEN)
  target_sources(xsystem35 PRIVATE cdrom.emscripten.c)
else()
  target_sources(xsystem35 PRIVATE cdrom.mp3.c)
endif()

if (EMSCRIPTEN)
  target_sources(xsystem35 PRIVATE midi.emscripten.c)
elseif (ANDROID)
  target_sources(xsystem35 PRIVATE midi.android.c)
else()
  target_sources(xsystem35 PRIVATE midi.sdlmixer.c)
  if (ENABLE_MIDI_PORTMIDI)
    target_sources(xsystem35 PRIVATE midi.portmidi.c midifile.c)
  endif()
endif()

if (EMSCRIPTEN)
  target_sources(xsystem35 PRIVATE menu_emscripten.c)
elseif (ANDROID)
  target_sources(xsystem35 PRIVATE menu_android.c)
elseif (ENABLE_GTK)
  target_sources(xsystem35 PRIVATE menu.c menu_callback.c menu_gui.c s39init.c)
else ()
  target_sources(xsystem35 PRIVATE menu_sdl.c sdl_input.c)
endif()

if (HAVE_WEBP)
  target_sources(xsystem35 PRIVATE webp.c)
  target_link_libraries(xsystem35 PRIVATE WebP)
endif()

if (ENABLE_DEBUGGER)
  target_sources(xsystem35 PRIVATE
    debug_symbol.c debugger.c debugger_cui.c debugger_dap.c)
endif()

if (WIN32)
  target_sources(xsystem35 PRIVATE
    win/dialog.c win/resources.rc win/resources.c win/menubar.c win/console.c)
endif()

target_link_libraries(src_lib PRIVATE sdl2 zlib)
target_link_libraries(xsystem35 PRIVATE m zlib sdl2 sdl2_ttf)
if (TARGET sdl2_mixer)
  target_link_libraries(xsystem35 PRIVATE sdl2_mixer)
endif()

if (EMSCRIPTEN)
  target_link_libraries(xsystem35 PRIVATE idbfs.js)

  # Without optimizations, Asyncify generates very large code.
  list(APPEND CMAKE_EXE_LINKER_FLAGS_DEBUG "-O1")

  target_link_options(xsystem35 PRIVATE
    -sENVIRONMENT=web
    -sMODULARIZE=1
    -sEXPORT_ES6=1
    -sASYNCIFY=1
    -sASYNCIFY_IGNORE_INDIRECT=1
    -sASYNCIFY_REMOVE=SDL_Delay
    -sASYNCIFY_IMPORTS=wait_vsync
    # Functions that call an asynchronous function via a function pointer must
    # be added to ASYNCIFY_ADD, even if it had a direct call to another
    # asynchronous function, so that the indirect call itself is instrumented.
    -sASYNCIFY_ADD=commands2F60,nact_main,send_agsevent,cb_waitkey_sprite
    -sALLOW_MEMORY_GROWTH=1
    -sNO_EXIT_RUNTIME=1
    -sEXPORTED_FUNCTIONS=_main,_malloc
    -sEXPORTED_RUNTIME_METHODS=FS,IDBFS,getValue,addRunDependency,removeRunDependency,stringToUTF8OnStack
    --emit-tsd=xsystem35.d.ts
    )

elseif (ANDROID)
  target_link_libraries(xsystem35 PRIVATE ${ndk_log})

else()  # non-emscripten, non-android
  if (TARGET cJSON)
    target_link_libraries(xsystem35 PRIVATE cJSON)
  endif()
  if (GTK3_FOUND)
    target_link_libraries(xsystem35 PRIVATE PkgConfig::GTK3)
  endif()
  if (ENABLE_MIDI_PORTMIDI)
    target_link_libraries(xsystem35 PRIVATE ${PORTMIDI})
  endif()

  install(TARGETS xsystem35 RUNTIME DESTINATION bin)

  add_executable(src_tests
    src_tests.c
    gameresource_test.c
    hankaku_test.c
    )
  target_compile_options(src_tests PRIVATE -Wno-pointer-sign -Wall)
  target_link_libraries(src_tests PRIVATE src_lib)
  add_test(NAME src_tests COMMAND src_tests)
  configure_file(testdata/test.gr ${CMAKE_CURRENT_BINARY_DIR}/testdata/test.gr COPYONLY)
endif()

=== android/app/jni/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14)

project(GAME)
set(PROJECT_ROOT_DIR ../../..)

# Compilation of SDL and companion libraries
include(FetchContent)
FetchContent_Declare(
  SDL
  URL https://github.com/libsdl-org/SDL/releases/download/release-2.30.9/SDL2-2.30.9.tar.gz
  URL_HASH SHA1=9403df0573d47f62f2de074b582b87576bb4abbc
)
FetchContent_Declare(
  SDL_ttf
  URL https://github.com/libsdl-org/SDL_ttf/releases/download/release-2.22.0/SDL2_ttf-2.22.0.tar.gz
  URL_HASH SHA1=da5e86b601ad299a697878fab1af6f3be47b529d
)
FetchContent_Declare(
  SDL_mixer
  URL https://github.com/libsdl-org/SDL_mixer/releases/download/release-2.8.0/SDL2_mixer-2.8.0.tar.gz
  URL_HASH SHA1=a58c69f9d00e44833b9e00e1adb58d85759ca499
)

set(SDL2TTF_SAMPLES OFF CACHE BOOL "Build the SDL2_ttf sample program(s)" FORCE)
set(SDL2TTF_INSTALL OFF CACHE BOOL "Enable SDL2_ttf install target" FORCE)
set(SDL2TTF_VENDORED ON CACHE BOOL "Use vendored third-party libraries" FORCE)

set(SDL2MIXER_OPUS OFF CACHE BOOL "Enable Opus music" FORCE)
set(SDL2MIXER_FLAC OFF CACHE BOOL "Enable FLAC music" FORCE)
set(SDL2MIXER_MOD  OFF CACHE BOOL "Support loading MOD music" FORCE)
set(SDL2MIXER_MIDI OFF CACHE BOOL "Enable MIDI music" FORCE)
set(SDL2MIXER_WAVPACK OFF CACHE BOOL "Enable WavPack music" FORCE)
set(SDL2MIXER_SAMPLES OFF CACHE BOOL "Build the SDL2_mixer sample program(s)" FORCE)
set(SDL2MIXER_INSTALL OFF CACHE BOOL "Enable SDL2_mixer install target" FORCE)

FetchContent_MakeAvailable(SDL SDL_ttf SDL_mixer)

# The main CMakeLists.txt of xsystem35
add_subdirectory(${PROJECT_ROOT_DIR} xsystem35)

# Copy asset files
set(ASSETS_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../src/main/assets)
file(MAKE_DIRECTORY ${ASSETS_DIR}/licenses)
file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/MTLc3m.ttf ${ASSETS_DIR}/MTLc3m.ttf)
file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/mincho.otf ${ASSETS_DIR}/mincho.otf)
file(COPY_FILE ${PROJECT_ROOT_DIR}/COPYING ${ASSETS_DIR}/licenses/xsystem35)
file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/MTLc3m.ttf.license ${ASSETS_DIR}/licenses/MTLc3m)
file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/mincho.otf.license ${ASSETS_DIR}/licenses/mincho)
file(COPY_FILE ${sdl_SOURCE_DIR}/LICENSE.txt ${ASSETS_DIR}/licenses/SDL)
file(COPY_FILE ${sdl_ttf_SOURCE_DIR}/LICENSE.txt ${ASSETS_DIR}/licenses/SDL_ttf)
file(COPY_FILE ${sdl_ttf_SOURCE_DIR}/external/freetype/docs/GPLv2.TXT ${ASSETS_DIR}/licenses/freetype)
file(COPY_FILE ${sdl_ttf_SOURCE_DIR}/external/harfbuzz/COPYING ${ASSETS_DIR}/licenses/harfbuzz)
file(COPY_FILE ${sdl_mixer_SOURCE_DIR}/LICENSE.txt ${ASSETS_DIR}/licenses/SDL_mixer)

## xsystem35 1.7.3-pre5

=== debian/changelog ===
xsystem35 (1.7.3-pre5-6) unstable; urgency=low

  * Drop dependencies of esound (Closes: #856097)
  * Bump debhelper version to 9
  * Bump Standards-Version to 4.1.2: Nothing needs to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 25 Dec 2017 04:53:13 +0800

xsystem35 (1.7.3-pre5-5) unstable; urgency=low

  * Build-Depends on libjpeg-dev instead of libjpeg62-dev (Closes: #647111)
  * Update debian/copyright to latest DEP-5 format.
  * Don't install duplicated usr/share/doc/xsystem35/ChangeLog

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 20 Nov 2011 16:06:51 +0800

xsystem35 (1.7.3-pre5-4) unstable; urgency=low

  * Bump Standards-Version to 3.9.2
    - Remove *.la files (Closes: #633226)
  * Use dh-autoreconf
  * Don't use embedded libltdl-dev
  * Fix multiarch rpath

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Fri, 22 Jul 2011 02:51:10 +0800

xsystem35 (1.7.3-pre5-3) unstable; urgency=low

  * debian/rules: Add -lX11 in LDFLAGS to fix FTBFS (Closes: #615804)
  * debian/copyright: Update to DEP-5 rev 173 format.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 16 Mar 2011 14:43:15 +0800

xsystem35 (1.7.3-pre5-2) unstable; urgency=low

  * debian/patches/02_use_utf8.patch: To be able to run in UTF-8 locale.
  * refine descriptions (Closes: #602710)
    - Thanks to Rupert Swarbrick <rswarbrick@gmail.com>
  * Update debian/copyright.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 09 Nov 2010 01:05:11 +0800

xsystem35 (1.7.3-pre5-1) unstable; urgency=low

  * Initial release (Closes: #594147)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 01 Sep 2010 02:28:39 +0800

=== debian/control ===
Source: xsystem35
Section: games
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, libgtk2.0-dev,
               libvorbis-dev, libjpeg-dev, xsltproc, docbook-xsl,
               libasound2-dev, libltdl-dev, dh-autoreconf,
	       autopoint, chrpath
Standards-Version: 4.1.2
Homepage: http://8ne.sakura.ne.jp:20008/chika/unitbase/xsys35/

Package: xsystem35
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: System 3.5 games engine for X Window System
 xsystem35 is a free implementation of System 3.5, a games engine created
 by Alice Soft. It is able to run many existing System 3.5 games.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DB2MAN=/usr/share/sgml/docbook/stylesheet/xsl/docbook-xsl/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --bindir=/usr/games \
		--libdir=/usr/lib/games/xsystem35 \
		--enable-audio=default,alsa,oss,esd \
		--enable-cdrom=default,linux,mp3 \
		--enable-midi=extp,raw,seq \
		LDFLAGS="$(LDFLAGS) -lX11 -lltdl"

override_dh_auto_build: xsystem35.6
	dh_auto_build
	chrpath -d $(CURDIR)/src/xsystem35

override_dh_auto_install:
	dh_auto_install
	find $(CURDIR)/debian/xsystem35/usr/lib -name "*.la" -exec rm {} \;

override_dh_installdocs:
	dh_installdocs -XChangeLog

xsystem35.6: debian/xsystem35.xml
	$(XP) $(DB2MAN) $<

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
# <Webpage URL> <string match>
http://8ne.sakura.ne.jp:20008/chika/unitbase/xsys35/download.html \
.*/xsystem35-(.*)\.tar\.gz

## xsystem35 2.13.0

=== debian/changelog ===
xsystem35 (2.13.0-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * Use SDL 2 port (Closes: #967840)
  * Drop patches
  * Drop old menu file
  * Unrecommend fonts-takao-mincho (which has changed to Source Han Serif)

 -- Bastian Germann <bage@debian.org>  Sun, 15 Dec 2024 21:20:31 +0000

xsystem35 (1.7.3-pre5-13) unstable; urgency=low

  * Use alternatives so that we can have different implementation of
    xsystem35.
    - Rename the binaries to xsystem35-x11.
    - Rename the manpages.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Fri, 30 Aug 2024 21:17:35 +0800

xsystem35 (1.7.3-pre5-12) unstable; urgency=low

  * Fix FTBFS for gcc-14 (Closes: #1075688)
    - Add debian/patches/06_fix_gcc_14_ftbfs.patch

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 07 Aug 2024 12:07:32 +0800

xsystem35 (1.7.3-pre5-11) unstable; urgency=low

  * Fix FTBFS by -Werror=implicit-function-declaration (Closes: #1066527)
    - Add debian/patches/05_fix_ftbfs_implicit-function-declaration.patch
  * debian/control: pkg-config -> pkgconf

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 01 Apr 2024 03:59:19 +0800

xsystem35 (1.7.3-pre5-10) unstable; urgency=low

  [ Ying-Chun Liu (PaulLiu) <paulliu@debian.org> ]
  * Upload Helmut's debdiff.
  [ Helmut Grohne <helmut@subdivi.de> ]
  * Fix FTCBFS: (Closes: #958676)
    + Use the host's pkg-config in debian/esd-config and
      debian/bin/freetype-config.
    + Export PKG_CONFIG for the earlier scripts.
    + Also kill broken copy macros/gtk-2.0.m4.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 31 Jan 2023 04:24:12 +0800

xsystem35 (1.7.3-pre5-9) unstable; urgency=low

  * Remove broken embedded copy of AM_PATH_GLIB_2_0 (Closes: #958676)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 26 Dec 2022 20:38:29 +0800

xsystem35 (1.7.3-pre5-8) unstable; urgency=low

  * Bump debhelper version to 11.
  * Add 04_esd_to_pulseaudio.patch and 04_sndcnv_64bit.patch
    - Fix audio not playable.
  * Update README.Debian
  * Bump Standards-Version to 4.4.1: Nothing needs to be changed

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Thu, 28 Nov 2019 02:14:40 +0800

xsystem35 (1.7.3-pre5-7) unstable; urgency=low

  * Bump debhelper version to 10.
    - Remove unnecessary build-dependencies: autotools-dev, dh-autoreconf
  * Fix debian/copyright format
  * Add debian/patches/02_modify_ttf_font_path.patch
    - It seems that we cannot draw xfonts anymore. All characters are blank.
      Thus we start using ttf to draw glyphs. Please see README.Debian
  * Move freetype-config to debian/bin and it will call pkg-config.
    - Add Build-Depends on pkg-config. (Closes: #892450)

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Tue, 06 Nov 2018 05:22:04 +0800

## xsystem35 2.14.2

=== debian/changelog ===
xsystem35 (2.14.2-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 31 Mar 2025 16:36:56 +0100

## xsystem35 2.14.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 enable_testing()
 set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
-set(XSYSTEM35_VERSION "2.13.0")
+set(XSYSTEM35_VERSION "2.14.3")
 
 include(CheckSymbolExists)
 include(FetchContent)
@@ -37,8 +37,8 @@
 function(fetch_webp)
   FetchContent_Declare(
     libwebp
-    URL https://storage.googleapis.com/downloads.webmproject.org/releases/webp/libwebp-1.4.0.tar.gz
-    URL_HASH SHA1=0b1c8bea200caaa010182609dbaaa91aec69b64d
+    URL https://storage.googleapis.com/downloads.webmproject.org/releases/webp/libwebp-1.5.0.tar.gz
+    URL_HASH SHA1=b21aa842136dc59a72a38776a5aa73f4d0b00ac5
     )
   set(WEBP_BUILD_ANIM_UTILS OFF CACHE BOOL "Build animation utilities." FORCE)
   set(WEBP_BUILD_CWEBP OFF CACHE BOOL "Build the cwebp command line tool." FORCE)

=== fonts/CMakeLists.txt ===
install(FILES
  MTLc3m.ttf
  MTLc3m.ttf.license
  mincho.otf
  mincho.otf.license
  DESTINATION share/xsystem35/fonts)

# pyftsubset is included in fonttools.
find_program(PYFTSUBSET_FOUND pyftsubset)

if (PYFTSUBSET_FOUND)
  add_custom_target(fonts
    COMMAND uchars > uchars.txt
    COMMAND wget -O SourceHanSerifJP-Regular.otf https://github.com/adobe-fonts/source-han-serif/blob/release/SubsetOTF/JP/SourceHanSerifJP-Regular.otf?raw=true
    COMMAND pyftsubset SourceHanSerifJP-Regular.otf --text-file=uchars.txt --output-file=subset.otf
    COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/adjust_metrics.py subset.otf ${CMAKE_CURRENT_SOURCE_DIR}/mincho.otf
    )
endif()

=== modules/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,12 @@
   AliceLogo/AliceLogo.c
   Confirm/Confirm.c
   Gpx/Gpx.c
+  Gpx/cg.c
   Gpx/effectcopy.c
+  Gpx/graph_copy_amap.c
+  Gpx/graph_fillrect_amap.c
+  Gpx/graph.c
+  Gpx/surface.c
   Math/Math.c
   MsgSkip/MsgSkip.c
   NIGHTDLL/NIGHTDLL.c
@@ -23,6 +28,7 @@
   NIGHTDLL/nt_sound.c
   NightDemonDemo/NightDemonDemo.c
   RandMT/RandMT.c
+  S3xMusic/S3xMusic.c
   SACT/SACT.c
   SACT/sactcg.c
   SACT/sactsound.c
@@ -60,27 +66,8 @@
   eeDemo/eeDemo.c
   lib/alk.c
   lib/drawtext.c
-  lib/graph.c
   lib/list.c
-  lib/surface.c
-  lib/cg.c
-  lib/graph_expandcolor_blend.c
-  lib/graph_fillrect.c
-  lib/graph_fillrect_amap.c
-  lib/graph_fillrect_acolor.c
-  lib/graph_rect.c
-  lib/graph_copy.c
-  lib/graph_copy_amap.c
-  lib/graph_copy_bright.c
   lib/graph_blend_amap.c
-  lib/graph_blend_screen.c
-  lib/graph_saturadd_amap.c
-  lib/graph_draw_amap.c
-  lib/graph_stretch.c
-  lib/graph_cg.c
-  lib/gre_blend_useamap.c
-  lib/gre_blend.c
-  lib/gre_blend_screen.c
   nDEMO/nDEMO.c
   nDEMOE/nDEMOE.c
   oDEMO/oDEMO.c

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -81,6 +81,7 @@
   s39ain.c
   savedata.c
   scenario.c
+  scheduler.c
   sdl_cursor.c
   sdl_draw.c
   sdl_effect.c

=== tools/CMakeLists.txt ===
add_executable(uchars EXCLUDE_FROM_ALL uchars.c)

=== android/app/jni/CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 include(FetchContent)
 FetchContent_Declare(
   SDL
-  URL https://github.com/libsdl-org/SDL/releases/download/release-2.30.9/SDL2-2.30.9.tar.gz
-  URL_HASH SHA1=9403df0573d47f62f2de074b582b87576bb4abbc
+  URL https://github.com/libsdl-org/SDL/releases/download/release-2.32.4/SDL2-2.32.4.tar.gz
+  URL_HASH SHA1=4fb68f43891ca4def414cc7cf0f3b2a053cb6aaf
 )
 FetchContent_Declare(
   SDL_ttf

=== android/app/jni/src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6)

project(MY_APP)

find_library(SDL2 SDL2)

add_library(main SHARED)

target_sources(main PRIVATE YourSourceHere.c)

target_link_libraries(main SDL2)

=== debian/changelog ===
xsystem35 (2.14.3-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Fri, 11 Apr 2025 22:32:10 +0100

## xsystem35 2.16.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,11 @@
-cmake_minimum_required(VERSION 3.13)
-
-# Rebuild external projects when download URL changes
-if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.24.0")
-  cmake_policy(SET CMP0135 NEW)
-endif()
+cmake_minimum_required(VERSION 3.13...4.0)
 
 project(xsystem35 LANGUAGES C)
 set(CMAKE_C_STANDARD 99)
 enable_testing()
 set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
-set(XSYSTEM35_VERSION "2.14.3")
+set(XSYSTEM35_VERSION "2.16.0")
 
 include(CheckSymbolExists)
 include(FetchContent)

=== debian/changelog ===
xsystem35 (2.16.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Wed, 13 Aug 2025 15:10:39 +0100

## xsystem35 2.16.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 enable_testing()
 set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
-set(XSYSTEM35_VERSION "2.16.0")
+set(XSYSTEM35_VERSION "2.16.1")
 
 include(CheckSymbolExists)
 include(FetchContent)

=== doc/CMakeLists.txt ===
set(SOURCES
  xsystem35.6.adoc
  xsystem35.gr.5.adoc
)

find_program(ASCIIDOCTOR asciidoctor)
if (NOT ASCIIDOCTOR)
  message(WARNING "asciidoctor not found, manpages will not be generated")
else()
  if (WIN32)
    set(BACKEND html)
  else()
    set(BACKEND manpage)
    include(GNUInstallDirs)
  endif()

  set(MANUALS "")
  foreach(SRC ${SOURCES})
    string(REGEX MATCH "^(.*)\\.([0-9])\\.adoc$" _ ${SRC})
    set(NAME ${CMAKE_MATCH_1})
    set(SECTION ${CMAKE_MATCH_2})
    if (WIN32)
      set(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.html)
    else()
      set(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${NAME}.${SECTION})
      install(FILES ${OUTPUT} DESTINATION ${CMAKE_INSTALL_MANDIR}/man${SECTION})
    endif()
    add_custom_command(
      OUTPUT ${OUTPUT}
      DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${SRC}
      COMMAND ${ASCIIDOCTOR}
        --attribute xsystem35-version=${XSYSTEM35_VERSION}
        --backend ${BACKEND}
        --out-file ${OUTPUT}
        ${CMAKE_CURRENT_SOURCE_DIR}/${SRC}
    )
    list(APPEND MANUALS ${OUTPUT})
  endforeach()

  add_custom_target(manual ALL DEPENDS ${MANUALS})
endif()

=== fonts/CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,6 @@
 install(FILES
   MTLc3m.ttf
-  MTLc3m.ttf.license
   mincho.otf
-  mincho.otf.license
   DESTINATION share/xsystem35/fonts)
 
 # pyftsubset is included in fonttools.

=== po/CMakeLists.txt ===
# This creates a target "translations"
gettext_create_translations(xsystem35.pot ALL ja.po)

add_custom_target(pot
  xgettext --default-domain=${PACKAGE} --directory=${CMAKE_SOURCE_DIR}
           --keyword=_ --keyword=N_
           --files-from=${CMAKE_CURRENT_SOURCE_DIR}/POTFILES.in
           --copyright-holder='Masaki Chikama'
           --output=${CMAKE_CURRENT_SOURCE_DIR}/xsystem35.pot
  )
add_dependencies(translations pot)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -59,9 +59,14 @@
   cursor.c
   dri.c
   ecopy.c
+  effect.c
+  event.c
   filecheck.c
   font.c
   hacks.c
+  gfx_draw.c
+  gfx_image.c
+  gfx_video.c
   image.c
   input.c
   jpeg.c
@@ -82,13 +87,8 @@
   savedata.c
   scenario.c
   scheduler.c
-  sdl_cursor.c
-  sdl_draw.c
-  sdl_effect.c
-  sdl_event.c
-  sdl_image.c
-  sdl_video.c
   selection.c
+  system.c
   texthook.c
   variable.c
   vsp.c
@@ -125,7 +125,7 @@
 elseif (ENABLE_GTK)
   target_sources(xsystem35 PRIVATE menu.c menu_callback.c menu_gui.c s39init.c)
 else ()
-  target_sources(xsystem35 PRIVATE menu_sdl.c sdl_input.c)
+  target_sources(xsystem35 PRIVATE menu_sdl.c editor.c)
 endif()
 
 if (HAVE_WEBP)
@@ -170,7 +170,7 @@
     -sALLOW_MEMORY_GROWTH=1
     -sNO_EXIT_RUNTIME=1
     -sEXPORTED_FUNCTIONS=_main,_malloc
-    -sEXPORTED_RUNTIME_METHODS=FS,IDBFS,getValue,addRunDependency,removeRunDependency,stringToUTF8OnStack
+    -sEXPORTED_RUNTIME_METHODS=FS,IDBFS,HEAPU8,HEAP16,getValue,addRunDependency,removeRunDependency,stringToUTF8OnStack
     --emit-tsd=xsystem35.d.ts
     )

=== android/app/jni/CMakeLists.txt ===
--- 
+++ 
@@ -44,8 +44,9 @@
 file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/MTLc3m.ttf ${ASSETS_DIR}/MTLc3m.ttf)
 file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/mincho.otf ${ASSETS_DIR}/mincho.otf)
 file(COPY_FILE ${PROJECT_ROOT_DIR}/COPYING ${ASSETS_DIR}/licenses/xsystem35)
-file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/MTLc3m.ttf.license ${ASSETS_DIR}/licenses/MTLc3m)
-file(COPY_FILE ${PROJECT_ROOT_DIR}/fonts/mincho.otf.license ${ASSETS_DIR}/licenses/mincho)
+file(COPY_FILE ${PROJECT_ROOT_DIR}/licenses/MTLc3m.txt ${ASSETS_DIR}/licenses/MTLc3m)
+file(COPY_FILE ${PROJECT_ROOT_DIR}/licenses/mincho.txt ${ASSETS_DIR}/licenses/mincho)
+file(COPY_FILE ${PROJECT_ROOT_DIR}/licenses/nanojpeg.txt ${ASSETS_DIR}/licenses/nanojpeg)
 file(COPY_FILE ${sdl_SOURCE_DIR}/LICENSE.txt ${ASSETS_DIR}/licenses/SDL)
 file(COPY_FILE ${sdl_ttf_SOURCE_DIR}/LICENSE.txt ${ASSETS_DIR}/licenses/SDL_ttf)
 file(COPY_FILE ${sdl_ttf_SOURCE_DIR}/external/freetype/docs/GPLv2.TXT ${ASSETS_DIR}/licenses/freetype)

=== debian/changelog ===
xsystem35 (2.16.1-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Sun, 31 Aug 2025 05:41:57 +0100

=== debian/control ===
Source: xsystem35
Section: games
Priority: optional
Maintainer: Ying-Chun Liu (PaulLiu) <paulliu@debian.org>
Build-Depends: asciidoctor,
               cmake,
               debhelper-compat (= 12),
               libcjson-dev,
               libgtk-3-dev,
               libjpeg-dev,
               libpulse-dev,
               libsdl2-dev,
               libsdl2-mixer-dev,
               libsdl2-ttf-dev,
               pkgconf,
Standards-Version: 4.4.1
Homepage: https://github.com/kichikuou/xsystem35-sdl2

Package: xsystem35
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, fonts-motoya-l-cedar
Suggests: timidity
Description: System 3.5 games engine for X Window System
 xsystem35 is a free implementation of System 3.5, a games engine created
 by Alice Soft. It is able to run many existing System 3.5 games.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/buildtools.mk
export PKG_CONFIG

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

execute_after_dh_auto_install:
	mkdir -p $(CURDIR)/debian/xsystem35/usr/games
	mv $(CURDIR)/debian/xsystem35/usr/bin/xsystem35 $(CURDIR)/debian/xsystem35/usr/games/xsystem35-x11
	mv $(CURDIR)/debian/xsystem35/usr/share/man/man6/xsystem35.6 $(CURDIR)/debian/xsystem35/usr/share/man/man6/xsystem35-x11.6
	rmdir $(CURDIR)/debian/xsystem35/usr/bin
	rm $(CURDIR)/debian/xsystem35/usr/share/xsystem35/fonts/MTLc3m.ttf*

override_dh_installdocs:
	dh_installdocs -XChangeLog

=== debian/watch ===
version=4
# <Webpage URL> <string match>
https://github.com/kichikuou/xsystem35-sdl2/tags \
.*/xsystem35-sdl2/archive/refs/tags/v([\d.]+)\.tar\.gz

## xsystem35 2.17.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 enable_testing()
 set(CMAKE_EXPORT_COMPILE_COMMANDS TRUE)
 
-set(XSYSTEM35_VERSION "2.16.1")
+set(XSYSTEM35_VERSION "2.17.0")
 
 include(CheckSymbolExists)
 include(FetchContent)

=== android/app/jni/CMakeLists.txt ===
--- 
+++ 
@@ -7,8 +7,8 @@
 include(FetchContent)
 FetchContent_Declare(
   SDL
-  URL https://github.com/libsdl-org/SDL/releases/download/release-2.32.4/SDL2-2.32.4.tar.gz
-  URL_HASH SHA1=4fb68f43891ca4def414cc7cf0f3b2a053cb6aaf
+  URL https://github.com/libsdl-org/SDL/releases/download/release-2.32.10/SDL2-2.32.10.tar.gz
+  URL_HASH SHA1=ce98fa93e31836a751feca374ab28a0770b63c16
 )
 FetchContent_Declare(
   SDL_ttf

=== debian/changelog ===
xsystem35 (2.17.0-1) unstable; urgency=low

  * New upstream release.

 -- Ying-Chun Liu (PaulLiu) <paulliu@debian.org>  Mon, 01 Dec 2025 10:21:27 +0000
